package com.agentfactory.afapl.compiler;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.afapl.interpreter.AFAPLAchieveStep;
import com.agentfactory.afapl.interpreter.Utilities;
import com.agentfactory.clf.interpreter.CoreUtilities;
import com.agentfactory.clf.lang.AND;
import com.agentfactory.clf.lang.IFormula;

public class SentenceBuilderVisitor implements AFAPLParserVisitor {

	@Override
	public Object visit(SimpleNode node, Object data) {
		if (node.toString().equals("Context")) {
			List<IFormula> list = new LinkedList<IFormula>();
			for (int i=0; i<node.jjtGetNumChildren(); i++) {
				if (node.jjtGetChild(i).toString().equals("Formula")) {
					SimpleNode litNode = (SimpleNode) node.jjtGetChild(i).jjtGetChild(0);
					if (litNode.toString().equals("Literal")) {
						String fos = "";
						if (litNode.jjtGetValue() != null) {
							fos += "~";
						}
						litNode = (SimpleNode) litNode.jjtGetChild(0);
						if (litNode.toString().equals("Predicate")) {
							fos += new PredicateBuilderVisitor().visit(litNode, null);
						} else if (litNode.toString().equals("Goal")) {
							fos += (String) litNode.jjtGetValue();
							fos += (String) new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						}
						list.add(Utilities.factory.createFormula(fos));
					} else if (litNode.toString().equals("Comparison")) {
						String fos = "" +new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						fos += litNode.jjtGetValue();
						fos += new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(1), null);
						list.add(CoreUtilities.factory.createFormula(fos));
					} else if (litNode.toString().equals("Goal")) {
						String fos = (String) litNode.jjtGetValue();
						fos += (String) new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						list.add(Utilities.factory.createFormula(fos));
					} else {
						System.out.println("Not Implemented Formula: " + litNode.toString());
					}
				} else {
					System.out.println("Not Implemented: " + node.jjtGetChild(i).toString());
				}
			}
			return new AND(list);
		}
		return null;
	}

}
