/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl.debugger;

import com.agentfactory.afapl.interpreter.AbstractAFAPLAgent;
import com.agentfactory.afapl.interpreter.Commitment;
import com.agentfactory.afapl.interpreter.GoalHandler;
import com.agentfactory.afapl.interpreter.Utilities;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.visualiser.impl.AbstractLanguageAgentStateManager;
import com.agentfactory.visualiser.impl.DefaultSnapshot;

/**
 *
 * @author remcollier
 */
public class AFAPLStateManager extends AbstractLanguageAgentStateManager {
    @Override
    protected DefaultSnapshot createSnapshot() {
        return new AFAPLSnapshot();
    }
    
    @Override
    protected void constructSnapshot(DefaultSnapshot shot) {
        super.constructSnapshot(shot);
        
        AbstractAFAPLAgent agt = (AbstractAFAPLAgent) agent;
        AFAPLSnapshot snap = (AFAPLSnapshot) shot;
        
        for(Predicate bel: agt.getBeliefs()) {
        	snap.beliefs.add(Utilities.presenter.toString(bel));
        }
        
        for (Commitment commitment: agt.getCommitments()) {
        	snap.commitments.add(new CommitmentDescription(commitment));
        }
        
        for (String action : agt.getActionLog()) {
        	snap.actionLog.add(action);
        }
        
        snap.rules = agt.getRules();
        
        snap.plans = agt.getPlans();
        
		for (GoalHandler handler:agt.getGoals()) {
			snap.goals.add(new GoalDescription(handler));
		}
    }
}
