package com.agentfactory.afapl.debugger;

import com.agentfactory.afapl.interpreter.AbstractAFAPLAgent;
import com.agentfactory.platform.core.IAgent;
import com.agentfactory.visualiser.core.IStateManager;
import com.agentfactory.visualiser.core.IStateManagerFactory;

public class AFAPLStateManagerFactory implements IStateManagerFactory {
	private int maxHistory;
	
    public void setMaxHistory(int maxHistory) {
    	this.maxHistory = maxHistory;
    }

	@Override
	public IStateManager createStateManager(IAgent agent) {
		IStateManager manager = new AFAPLStateManager();
		manager.setMaxHistory(maxHistory);
		manager.setAgent(agent);
		return manager;
	}

	@Override
	public String getType() {
		return AbstractAFAPLAgent.TYPE;
	}
}
