package com.agentfactory.afapl.interpreter;

import com.agentfactory.clf.interpreter.AbstractLanguageAgent;
import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.plans.IPlanStep;
import com.agentfactory.clf.plans.UpdateStep;
import com.agentfactory.clf.reasoner.Bindings;


public class AFAPLUpdateStep extends UpdateStep {

	public AFAPLUpdateStep(String op, IFormula step) {
		super(op, step);
	}

	protected void adopt(AbstractLanguageAgent agent, IFormula formula) {
		super.adopt(agent, formula);
		
		AbstractAFAPLAgent agt = (AbstractAFAPLAgent) agent;
		if (Goal.class.isInstance(formula)) {
			Goal goal = (Goal) formula.apply(new Bindings());
			agt.addGoal(goal);
		}
	}
	
	protected void drop(AbstractLanguageAgent agent, IFormula formula) {
		super.drop(agent, formula);
		
		AbstractAFAPLAgent agt = (AbstractAFAPLAgent) agent;
		if (Goal.class.isInstance(formula)) {
			Goal goal = (Goal) formula.apply(new Bindings());
			agt.removeGoal(goal);
		}
	}
	
	@Override
	public IPlanStep apply(Bindings set) {
		return new AFAPLUpdateStep(op, step.apply(set));
	}

	@Override
	public String toString() {
		return op + Utilities.presenter.toString(step);
	}
}
