package com.agentfactory.afapl.interpreter;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.clf.plans.IPlanStep;
import com.agentfactory.clf.reasoner.Bindings;

public class CommitmentRule {
	Predicate label;
	IFormula condition;
	List<IPlanStep> plan;
	
	public CommitmentRule(Predicate label, IFormula condition, List<IPlanStep> plan) {
		this.label = label;
		this.condition = condition;
		this.plan = plan;
	}
	
	public CommitmentRule apply(Bindings set) {
		List<IPlanStep> _plan = new LinkedList<IPlanStep>();
		for (IPlanStep step : plan) {
			_plan.add(step.apply(set));
		}
		return new CommitmentRule(label, condition.apply(set), _plan);
	}
	
	public String toString() {
		String output = Utilities.presenter.toString(condition) + " <-\n";
		for (IPlanStep step : plan) {
			output += "\t" + step.toString() + "\n";
		}
		return output;
	}
}
