package com.agentfactory.afapl.interpreter;

import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.clf.plans.BlockStep;
import com.agentfactory.clf.reasoner.Bindings;

public class Plan {
	Predicate identifier;
	IFormula pre;
	IFormula post;
	BlockStep plan;
	
	public Plan(Predicate predicate, IFormula pre, IFormula post, BlockStep plan) {
		this.identifier = predicate;
		this.pre = pre;
		this.post = post;
		this.plan = plan;
	}
	
	public Plan apply(Bindings bindings) {
		return new Plan(identifier, pre.apply(bindings), post.apply(bindings), (BlockStep) plan.apply(bindings));
	}
	
	public String toString() {
		String output = "plan " + Utilities.presenter.toString(identifier) + " {\n";
		output += "\tpre " + Utilities.presenter.toString(pre) + ";\n";
		output += "\tpost " + Utilities.presenter.toString(post) + ";\n";
		output += "\tbody " + plan.toString() + ";\n";
		output += "}";
		return output;
	}
}
