/*
 * ClassCheckVisitor.java
 *
 * Created on 19 June 2006, 11:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import com.agentfactory.afapl2.compiler.parser.Visitor;
import com.agentfactory.afapl2.compiler.parser.node.FOSNode;
import com.agentfactory.afapl2.compiler.parser.node.Node;
/**
 *
 * @author Administrator
 */
public class VariableExtractor extends Visitor {
    private List<String> variables;

    public VariableExtractor() {
        super(new ArrayList<AFAPL2SyntaxError>(), new ArrayList<AFAPL2SyntaxError>());

        variables = new LinkedList<String>();
    }
    
    @Override
	public void visit(Node node) {
        if (node instanceof FOSNode) {
            visit((FOSNode) node);
        } else {
            throw new RuntimeException("Attempted to visit a Node instance: " + node);
        }
    }
    
    private void visit(FOSNode node) {
        if (node.isVariable()) {
            variables.add(node.toString());
        } else if (node.isComposite()) {
            for (FOSNode arg: node.getArguments()) {
                arg.accept(this);
            }
        }
    }

    public List<String> getVariables() {
        return variables;
    }
}
