/*
 * Visitor.java
 *
 * Created on 19 June 2006, 11:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.afapl2.compiler.AFAPL2SyntaxError;
import com.agentfactory.afapl2.compiler.parser.node.Node;

/**
 *
 * @author Administrator
 */
public abstract class Visitor {
    private List<AFAPL2SyntaxError> warnings = new LinkedList<AFAPL2SyntaxError>();
    private List<AFAPL2SyntaxError> errors = new LinkedList<AFAPL2SyntaxError>();
    
    public Visitor(List<AFAPL2SyntaxError> errors, List<AFAPL2SyntaxError> warnings) {
        this.errors = errors;
        this.warnings = warnings;
    }

    public void addError(String source, long line, String message) {
        errors.add(new AFAPL2SyntaxError(AFAPL2SyntaxError.ERROR, source, line, message));
    }
    
    public void addError(String source, long line, String message, String issue) {
        errors.add(new AFAPL2SyntaxError(AFAPL2SyntaxError.ERROR, source, line, message, issue));
    }
    
    public void addWarning(String source, long line, String issue) {
        warnings.add(new AFAPL2SyntaxError(AFAPL2SyntaxError.WARNING, source, line, null, issue));
    }
    
    public void addWarning(String source, long line, String message, String issue) {
        warnings.add(new AFAPL2SyntaxError(AFAPL2SyntaxError.WARNING, source, line, message, issue));
    }
    
    public List<AFAPL2SyntaxError> getErrors() {
        return errors;
    }
    
    public List<AFAPL2SyntaxError> getWarnings() {
        return warnings;
    }
    
    public abstract void visit(Node node);
}
