/*
 * ProgramNode.java
 *
 * Created on 13 June 2006, 14:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.node;

import com.agentfactory.afapl2.compiler.parser.LexicalAnalyser;
import com.agentfactory.afapl2.compiler.parser.LexicalAnalyserException;
import com.agentfactory.afapl2.compiler.parser.ParseTreeException;
import com.agentfactory.afapl2.compiler.parser.ParserHelper;

/**
 *
 * @author Administrator
 */
public class InRangeNode extends ModalNode {
    private FOSNode value;
    private FOSNode min;
    private FOSNode max;
    
    /** Creates a new instance of ProgramNode */
    public InRangeNode() {
    }
    
    @Override
	public void construct(LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
        // BELIEF construct syntax: GREATER_THAN(<fosNode>, <fosNode>)
        
        // Step 1: Check for open bracket "("
        ParserHelper.punctuationCheck("(", "Syntax Error in IN_RANGE", "expected ( but found", analyser);
        
        // Step 2: Get the value part of the range check...
        value = FOSNode.createFOS(analyser.getNextToken(), analyser);

        // Step 3: Check for a comma
        ParserHelper.punctuationCheck(",", "Syntax Error in IN_RANGE(" + value, "expected , but found", analyser);
        
        // Step 4: Get the min part of the comparison...
        min= FOSNode.createFOS(analyser.getNextToken(), analyser);
        
        // Step 5: Check for a comma
        ParserHelper.punctuationCheck(",", "Syntax Error in IN_RANGE(" + value + "," + min, "expected , but found", analyser);
        
        // Step 6: Get the max part of the range check...
        max= FOSNode.createFOS(analyser.getNextToken(), analyser);

        // Step 7: Check for an close bracket ")
        ParserHelper.punctuationCheck(")", "Syntax Error in IN_RANGE(" + value+ "," + min + "," + max, "expected ) but found", analyser);
    }
    
    @Override
	public String toString() {
        return "IN_RANGE(" + value + "," + min + "," + ")";
    }
}
