/*
 * Token.java
 *
 * Created on 13 June 2006, 14:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.token;

import java.util.HashMap;

import com.agentfactory.afapl2.compiler.parser.reader.Reader;
import java.util.Map;
/**
 *
 * @author Administrator
 */
public class Token {
    private static Map<String,String> tokens;
    
    static {
        tokens = new HashMap<String,String>();
        
        // TODO (Rem Collier): Load tokens from a file...
        tokens.put("(", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put(")", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put("{", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put("}", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put("!", "com.agentfactory.afapl2.compiler.parser.token.NotToken");
        tokens.put(",", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put("=", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put(";", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put(":", "com.agentfactory.afapl2.compiler.parser.token.PunctuationToken");
        tokens.put("BELIEF", "com.agentfactory.afapl2.compiler.parser.token.BeliefToken");
        tokens.put("COMMIT", "com.agentfactory.afapl2.compiler.parser.token.CommitToken");
        tokens.put("IMPORT", "com.agentfactory.afapl2.compiler.parser.token.ImportToken");
        tokens.put("PERCEPTOR", "com.agentfactory.afapl2.compiler.parser.token.PerceptorToken");
        tokens.put("LOAD_MODULE", "com.agentfactory.afapl2.compiler.parser.token.ModuleToken");
        tokens.put("ALWAYS", "com.agentfactory.afapl2.compiler.parser.token.AlwaysToken");
        tokens.put("NEXT", "com.agentfactory.afapl2.compiler.parser.token.NextToken");
        tokens.put("UNTIL", "com.agentfactory.afapl2.compiler.parser.token.UntilToken");
        tokens.put("ACTION", "com.agentfactory.afapl2.compiler.parser.token.ActionToken");
        tokens.put("PRECONDITION", "com.agentfactory.afapl2.compiler.parser.token.OptionToken");
        tokens.put("POSTCONDITION", "com.agentfactory.afapl2.compiler.parser.token.OptionToken");
        tokens.put("CLASS", "com.agentfactory.afapl2.compiler.parser.token.OptionToken");
        tokens.put("LESS_THAN", "com.agentfactory.afapl2.compiler.parser.token.LessThanToken");
        tokens.put("GREATER_THAN", "com.agentfactory.afapl2.compiler.parser.token.GreaterThanToken");
        tokens.put("EQUAL", "com.agentfactory.afapl2.compiler.parser.token.EqualToken");
        tokens.put("IN_RANGE", "com.agentfactory.afapl2.compiler.parser.token.InRangeToken");
        tokens.put("ROLE", "com.agentfactory.afapl2.compiler.parser.token.RoleToken");
        tokens.put("TRIGGER", "com.agentfactory.afapl2.compiler.parser.token.TriggerToken");
        tokens.put("ONTOLOGY", "com.agentfactory.afapl2.compiler.parser.token.OntologyToken");
        tokens.put("PLAN", "com.agentfactory.afapl2.compiler.parser.token.PlanToken");        
        tokens.put("BODY", "com.agentfactory.afapl2.compiler.parser.token.OptionToken");
        tokens.put("GOAL", "com.agentfactory.afapl2.compiler.parser.token.GoalToken");
    }
    
    public static Token createToken(String text, long line, Reader reader) {
        // Start with character based tokens
        String firstCharacter = text.substring(0,1);
        String type = tokens.get(firstCharacter);
        
        if (type == null) {
            // Now try to match the whole text...
            type = tokens.get(text);
            
            if (type == null) {
                type = "com.agentfactory.afapl2.compiler.parser.token.ConstantToken";
            }
        }
        
        Token token = null;
        try {
            Class tokenClass = Class.forName(type);
            token = (Token) tokenClass.newInstance();
            token.text = text;
            token.line = line;
            token.reader = reader;
        } catch (ClassNotFoundException cnfe) {
            System.out.println("[Token] Error when creating token: could not find the class - " + type);
        } catch(IllegalAccessException iae) {
            System.out.println("[Token] Error when creating token: could not create an instance of the class - " + type);
        } catch(InstantiationException ie) {
            System.out.println("[Token] Error when creating token: could not create an instance of the class - " + type);
        }
        
        return token;
    }
    
    private String text;
    private long line;
    private Reader reader;
    
    public long getLine() {
        return line;
    }
    
    public Reader getReader() {
        return reader;
    }
    
    public String getText() {
        return text;
    }
    
    public String getNodeType() {
        // Return null to indicate that this token has no associated node type...
        return null;
    }
}
