/*									tab:4
 * Copyright (c) 2007 University College Dublin.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL UNIVERSITY COLLEGE DUBLIN BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
 * UNIVERSITY COLLEGE DUBLIN HAS BEEN ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * UNIVERSITY COLLEGE DUBLIN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND UNIVERSITY COLLEGE DUBLIN HAS NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 *
 *
 */

package com.agentfactory.afapl2.core.actuator;

import java.util.List;

import com.agentfactory.logic.agent.Actuator;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.reasoner.Substitution;
import com.agentfactory.logic.reasoner.SubstitutionSet;

/**
 *
 * @author  Mauro Dragone
 */
public class BreakSequence extends Actuator {
  @Override
public boolean act(FOS action) {
      FOS sequence = action.argAt(0);
      FOS template = action.argAt(1);      
      List<FOS> variables = template.getVariables();
      
      for (int i=0; i< sequence.numArguments(); i++) {
           // prepare the substitution which will subsitute every
           // variable in the template with the current argument from the sequence
           SubstitutionSet subSet = new SubstitutionSet();
           for (FOS var: variables) {
                subSet.addBinding(new Substitution(var, sequence.argAt(i)));
           }
           FOS fos = template.copy().apply(subSet);
           agent.adoptBelief(new FOS("BELIEF("+fos.toString()+")"));
      }

      return true;
  }
}
