/*									tab:4
 * Copyright (c) 2007 University College Dublin.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL UNIVERSITY COLLEGE DUBLIN BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
 * UNIVERSITY COLLEGE DUBLIN HAS BEEN ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * UNIVERSITY COLLEGE DUBLIN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND UNIVERSITY COLLEGE DUBLIN HAS NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 *
 *
 */

package com.agentfactory.afapl2.core.perceptor;

import java.util.List;

import com.agentfactory.afapl2.core.module.EISControlModule;
import com.agentfactory.logic.agent.Belief;
import com.agentfactory.logic.agent.Perceptor;
import com.agentfactory.logic.lang.FOS;

/**
 *
 * @author  Mauro Dragone
 */
public class AuxiliaryMemoryPerceptor extends Perceptor {

  @Override
public void perceive() {
       EISControlModule auxMemory = (EISControlModule) getModuleByName("auxiliaryMemory");
       if (auxMemory == null) {
            adoptBelief("BELIEF(noSuchModule(auxiliaryMemory))");
            return;
       }
       
       String memoryName = this.getConfiguration().get("name");
       if (!auxMemory.isEnabled(memoryName))
           return;
       
       List<FOS> set = auxMemory.getMemory(memoryName);       
       for (FOS belief:set) {
           Belief bel = new Belief(belief);           
           adoptBelief(bel);
       }                     
  }
}
