package com.agentfactory.afapl2.core.perceptor;

import com.agentfactory.logic.agent.Belief;
import com.agentfactory.logic.agent.Perceptor;
import com.agentfactory.service.ams.AgentManagementService;

/**
 *
 * @author  remcollier
 */
public class LocalAgents extends Perceptor {

    @Override
	public void perceive() {
        AgentManagementService ams = (AgentManagementService) getService(AgentManagementService.NAME);
        if (ams == null) {
            adoptBelief("BELIEF(notBoundToService(" + AgentManagementService.NAME + "))");
        } else {
            for (String name: ams.getAgentNames()) {
                Belief belief = createBelief("localAgent");
                belief.bind("?name", name);
                adoptBelief(belief);
            }
        }
    }
}
