package com.agentfactory.afapl2.core.perceptor;

import com.agentfactory.afapl2.interpreter.AbstractAFAPL2Agent;
import com.agentfactory.afapl2.interpreter.control.RoleLibrary;
import com.agentfactory.afapl2.interpreter.control.RoleTemplate;
import com.agentfactory.afapl2.interpreter.mentalState.Role;
import com.agentfactory.logic.agent.Perceptor;

public class RolePerceptor extends Perceptor {
    @Override
	public void perceive() {
        RoleLibrary library = ((AbstractAFAPL2Agent) agent).getRoleLibrary();

        for (Role role:library.getInstances()) {
            adoptBelief("BELIEF(enactingRole(" + role.getIdentifier().toString() + "))");
        }
        
        for (RoleTemplate template:library.getRoles()) {
            adoptBelief("BELIEF(role(" + template.getIdentifier() + "))");
        }
    }
}
