/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.inspector;

import java.awt.BorderLayout;
import java.awt.event.MouseListener;

import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.JToolBar;

import com.agentfactory.afapl2.debugger.AFAPL2Snapshot;
import com.agentfactory.afapl2.debugger.model.CommitmentDescription;
import com.agentfactory.afapl2.debugger.model.GoalDescription;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;


/**
 *
 * @author remcollier
 */
public class GoalsPanel extends JPanel implements InspectorPanel {
    private AFAPL2Snapshot snapshot;
    private JList goals;
    private JList options;
    private JTextField commitment;
    
    public GoalsPanel() {
        setLayout(new BorderLayout());
        goals = new JList(new DefaultListModel());
        goals.addMouseListener(new MouseListener() {
            public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
                GoalDescription goal = (GoalDescription) goals.getSelectedValue();
                DefaultListModel model = (DefaultListModel) options.getModel();
                if (goal != null) {
                    model.removeAllElements();
                    for (String option: goal.getOptions()) {
                        model.addElement(option);
                    }
                    
                    CommitmentDescription com = goal.getCommitment();
                    if (com != null) {
                        commitment.setText(com.toString());
                    } else {
                        commitment.setText("");
                    }
                            
                }
            }
            
            public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {}
            public void mousePressed(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseExited(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {}
        });
        
        goals.setCellRenderer(new DefaultListCellRenderer() {
            @Override
			public java.awt.Component getListCellRendererComponent(javax.swing.JList list, Object value, int index, boolean iss, boolean chf) {
                JLabel label = (JLabel) super.getListCellRendererComponent(list, value.toString(), index, iss, chf);

                if (value instanceof GoalDescription) {
                    GoalDescription description = (GoalDescription) value;
                    label.setText( description.getGoal() );
                }

                return label;
            }
        });
        
        JToolBar toolbar = new JToolBar();
        toolbar.add(new JLabel("Goals:"));
        JPanel panel = new JPanel(new BorderLayout());
        JScrollPane scrollPane = new JScrollPane(goals);
        panel.add(BorderLayout.NORTH, toolbar);
        JSplitPane pane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        panel.add(BorderLayout.CENTER, scrollPane);
        options = new JList(new DefaultListModel());
        pane.setTopComponent(panel);
        toolbar = new JToolBar();
        toolbar.add(new JLabel("Options:"));
        panel = new JPanel(new BorderLayout());
        scrollPane = new JScrollPane(options);
        panel.add(BorderLayout.NORTH, toolbar);
        panel.add(BorderLayout.CENTER, scrollPane);
        JPanel dPanel = new JPanel(new BorderLayout());
        toolbar = new JToolBar();
        toolbar.add(new JLabel("Commitment:"));
        dPanel.add(BorderLayout.NORTH, toolbar);
        commitment = new JTextField();
        dPanel.add(BorderLayout.CENTER, commitment);
        panel.add(BorderLayout.SOUTH, dPanel);
        pane.setBottomComponent(panel);
        this.add(BorderLayout.CENTER, pane);
    }
    
    public void update(ISnapshot _snapshot) {
        snapshot = (AFAPL2Snapshot) _snapshot;
        DefaultListModel model = (DefaultListModel) goals.getModel();
        model.removeAllElements();
        
        commitment.setText("");
        ((DefaultListModel) options.getModel()).removeAllElements();
        
        for (GoalDescription goal: snapshot.getGoals()) {
            model.addElement(goal);
        }
    }

}
