/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.inspector;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.MouseListener;

import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JToolBar;

import com.agentfactory.afapl2.debugger.AFAPL2Snapshot;
import com.agentfactory.logic.agent.Function;
import com.agentfactory.logic.agent.Ontology;
import com.agentfactory.logic.agent.Predicate;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

/**
 *
 * @author remcollier
 */
public class OntologyPanel extends JPanel implements InspectorPanel {
    private AFAPL2Snapshot snapshot;
    private JList ontologies;
    private JList predicates, functions;
    
    public OntologyPanel() {
        setLayout(new BorderLayout());
        ontologies = new JList(new DefaultListModel());
        ontologies.addMouseListener(new MouseListener() {
            public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
                Ontology ontology = (Ontology) ontologies.getSelectedValue();
                if (ontology != null) {
                    DefaultListModel model = (DefaultListModel) predicates.getModel();
                    model.removeAllElements();
                    for (Predicate predicate: ontology.getPredicates()) {
                        model.addElement(predicate);
                    }
                    model = (DefaultListModel) functions.getModel();
                    model.removeAllElements();
                    for (Function function: ontology.getFunctions()) {
                        model.addElement(function);
                    }
                }
            }
            
            public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {}
            public void mousePressed(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseExited(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {}
        });
        ontologies.setCellRenderer(new DefaultListCellRenderer() {
            @Override
			public java.awt.Component getListCellRendererComponent(javax.swing.JList list, Object value, int index, boolean iss, boolean chf) {
                JLabel label = (JLabel) super.getListCellRendererComponent(list, value.toString(), index, iss, chf);
                label.setText( ((Ontology) value).getIdentifier() );
                return label;
            }
        });
        
        JToolBar toolbar = new JToolBar();
        toolbar.add(new JLabel("Ontologies:"));
        JPanel panel = new JPanel(new BorderLayout());
        JScrollPane scrollPane = new JScrollPane(ontologies);
        panel.add(BorderLayout.NORTH, toolbar);
        JSplitPane pane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        panel.add(BorderLayout.CENTER, scrollPane);
        pane.setTopComponent(panel);
        
        JPanel main = new JPanel(new GridLayout(0,2));
        toolbar = new JToolBar();
        toolbar.add(new JLabel("Predicates:"));
        panel = new JPanel(new BorderLayout());
        predicates = new JList(new DefaultListModel());
        scrollPane = new JScrollPane(predicates);
        panel.add(BorderLayout.NORTH, toolbar);
        panel.add(BorderLayout.CENTER, scrollPane);
        main.add(panel);

        toolbar = new JToolBar();
        toolbar.add(new JLabel("Functions:"));
        panel = new JPanel(new BorderLayout());
        functions = new JList(new DefaultListModel());
        scrollPane = new JScrollPane(functions);
        panel.add(BorderLayout.NORTH, toolbar);
        panel.add(BorderLayout.CENTER, scrollPane);
        main.add(panel);
        
        pane.setBottomComponent(main);
        this.add(BorderLayout.CENTER, pane);
    }
    
    public void update(ISnapshot _snapshot) {
        snapshot = (AFAPL2Snapshot) _snapshot;
        DefaultListModel model = (DefaultListModel) ontologies.getModel();
        model.removeAllElements();
        
        for (Ontology ontology: snapshot.getOntologies()) {
            model.addElement(ontology);
        }
    }

}
