/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.inspector;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.MouseListener;

import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import com.agentfactory.afapl2.debugger.AFAPL2Snapshot;
import com.agentfactory.afapl2.debugger.model.PlanDescription;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

/**
 *
 * @author remcollier
 */
public class PlansPanel extends JPanel implements InspectorPanel {
    private JList list;
    private JTextField preCondition;
    private JTextField postCondition;
    private JTextField body;
    private JPanel details;
    
    public class CellRenderer extends DefaultListCellRenderer {
        @Override
		public java.awt.Component getListCellRendererComponent(javax.swing.JList list, Object value, int index, boolean iss, boolean chf) {
            JLabel label = (JLabel) super.getListCellRendererComponent(list, value.toString(), index, iss, chf);
            label.setText( ((PlanDescription) value).getIdentifier() );
            return label;
        }
    }
    
    public PlansPanel() {
        this.setLayout(new BorderLayout());
        
        list = new JList(new DefaultListModel());
        JScrollPane pane = new JScrollPane(list);
        this.add(BorderLayout.CENTER, pane);
        details = new JPanel();
        details.setLayout(new GridLayout(3, 2));
        details.add(new JLabel("Pre Conditions:"));
        preCondition = new JTextField();
        details.add(preCondition);
        details.add(new JLabel("Post Conditions:"));
        postCondition = new JTextField();
        details.add(postCondition);
        details.add(new JLabel("Body:"));
        body = new JTextField();
        details.add(body);
        this.add(BorderLayout.SOUTH, details);
        
        list.setCellRenderer(new CellRenderer());
        list.addMouseListener(new MouseListener() {
            public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
                PlanDescription description = (PlanDescription) ((JList) mouseEvent.getSource()).getSelectedValue();
                if ( description == null ) {
                    preCondition.setText("");
                    postCondition.setText("");
                    body.setText("");
                } else {
                    preCondition.setText(description.getPreCondition());
                    postCondition.setText(description.getPostCondition());
                    body.setText(description.getBody().toString());
                }
            }
            
            public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {}
            public void mousePressed(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseExited(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {}
        });
    }
    
    public void update(ISnapshot _snapshot) {
        AFAPL2Snapshot snapshot = (AFAPL2Snapshot) _snapshot;
        DefaultListModel model = (DefaultListModel) list.getModel();
        model.removeAllElements();
        
        for (PlanDescription plan: snapshot.getPlans()) {
            model.addElement(plan);
        }
    }
}
