/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.model;

import java.util.ArrayList;
import java.util.List;

import com.agentfactory.afapl2.interpreter.mentalState.Commitment;

/**
 *
 * @author remcollier
 */
public class CommitmentDescription {
    private String to;
    private String when;
    private String maintenance;
    private String activity;
    private List<Integer> children;
    
    public CommitmentDescription(List<Commitment> commitments, Commitment commitment) {
        to = commitment.getTo().toString();
        when = commitment.getStartTime().toString();
        maintenance = commitment.getMaintenanceCondition().toString();
        activity = commitment.getActivity().toString();
        children = new ArrayList<Integer>();
        for (Commitment com : commitments) {
            if (commitment.equals(com.getParent())) {
                children.add(commitments.indexOf(com));
            }
        }
    }
    
    public String getTo() {
        return to;
    }
    
    public String getWhen() {
        return when;
    }
    
    public String getMaintenance() {
        return maintenance;
    }
    
    public String getActivity() {
        return activity;
    }
    
    public List<Integer> getChildren() {
        return children;
    }
    
    @Override
    public String toString() {
        return "COMMIT(" + to + "," + when + "," + maintenance + "," + activity + ")";
    }
}
