/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.model;

import java.io.Serializable;
import java.util.LinkedList;
import java.util.List;

import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
import com.agentfactory.afapl2.interpreter.mentalState.Goal;
import com.agentfactory.logic.lang.FOS;

/**
 *
 * @author remcollier
 */
public class GoalDescription implements Serializable {
    private String goal;
    private List<String> options;
    private CommitmentDescription commitment;
    
    public GoalDescription(Goal goal) {
        this.goal = goal.toString();
        options = new LinkedList<String>();
        for (FOS obj: goal.getOptions()) {
            options.add(obj.toString());
        }
        
        if (goal.getCommitment() != null) {
            commitment = new CommitmentDescription(new LinkedList<Commitment>(), goal.getCommitment());
        }
    }
    
    public String getGoal() {
        return goal;
    }
    
    public List<String> getOptions() {
        return options;
    }
    
    public CommitmentDescription getCommitment() {
        return commitment;
    }
}
