/*
 * InterpreterHelper.java
 *
 * Created on 28 January 2005, 19:34
 */

package com.agentfactory.afapl2.interpreter;

import java.util.Calendar;
import java.util.StringTokenizer;

import com.agentfactory.logic.lang.FOS;
/**
 *
 * @author  Administrator
 */
public class InterpreterHelper {
    // TODO(claudiagrigore): This class is hardly used now. Remove it?
    
    public static String createSignature(FOS fos) {
        return fos.getFunctor() + ":" + fos.numArguments();
    }
    /**
     * Build a time object out of the start time on the commitment defintion
     *
     * Users can specify the time in three formats
     *    a) now
     *    b) 00.40      (time in 24 hour format)
     *    c) +90        (relative time in minutes)
     *
     */
    public static Calendar timeFromString(String inTime) {
        // Construct a default date based on the current time
        Calendar returnValue = Calendar.getInstance();
        
        // Check the input string
        if(inTime.toLowerCase().equals("now")) {
            // user selected now...  the defult current date is fine
            return returnValue;
        }
        else if(inTime.toLowerCase().equals("?now")) {
            // user selected now...  the defult current date is fine
            return returnValue;
        }
        else if(inTime.startsWith("+")) {
            // user wants a relative time
            // format should be +X where X is some positive integer
            StringTokenizer st = new StringTokenizer(inTime);
            if(st == null) {
                throw new IllegalArgumentException("relative time badly formed");
            }
            String minsAsString = st.nextToken("+");
            if(minsAsString == null) {
                throw new IllegalArgumentException("relative time badly formed");
            }
            int total_mins = Integer.parseInt(minsAsString);
            // Convert this amount of mins to hours and seconds
            returnValue.add(Calendar.MINUTE, total_mins);
        }
        else {
            // should be a 24 hour format time
            StringTokenizer st = new StringTokenizer(inTime, ".");
            String string1 = st.nextToken();
            String string2 = st.nextToken();
            int hourBit = 0;
            int minuteBit = 0;
            try {
                hourBit = Integer.parseInt(string1);
                minuteBit = Integer.parseInt(string2);
            }
            catch (Exception e) {
                System.out.println(string1);
                System.out.println(string2);
                e.printStackTrace();
            }
            
            
            if( (hourBit < 0) || (hourBit > 23) ) {
                // error ... hours not between 0 and 23
                throw new IllegalArgumentException("error hour was not in range 0 to 23");
            }
            if( (minuteBit < 0) || (minuteBit > 59) ) {
                throw new IllegalArgumentException("error minute was not in range 0 to 59");
            }
            returnValue.set(Calendar.HOUR_OF_DAY, hourBit);
            returnValue.set(Calendar.MINUTE, minuteBit);
            
            // Say the current time is 23.30 and a commitment rule was to be
            // fired at 00.30, then I need to make sure that my calendar date
            // corresponds to tomorrow at 00.30 rather than earlier today
            // at 00.30. This code takes care of that
            if(Calendar.getInstance().after(returnValue)) {
                // Add one day
                returnValue.add(Calendar.MINUTE, (60*24));
            }
        }
        return returnValue;
    }
    
    public static String timeAsString(Calendar time) {
        // Make sure the number bit of time has a zero at the start of it
        // i.e. make sure time looks like 12.01, rather than 12.1
        int minuteBit = time.get(Calendar.MINUTE);
        String minuteString = null;
        if(minuteBit < 10) {
            minuteString = "0" + minuteBit;
        }
        else {
            minuteString = "" + minuteBit;
        }

        return time.get(Calendar.HOUR_OF_DAY) + "." + minuteString;
    }
}
