/*
 * PARActivityHandler.java
 *
 * Created on 11 November 2005, 09:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.control.cms;

import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
import com.agentfactory.logic.lang.FOS;

/**
 *
 * @author Administrator
 */
public class DELAYActivityHandler extends ActivityHandler {
    public static final int ITERATION                                   = 0;
    public static final int TIME                                        = 1;
    
    private int type;
    private long time;
    private long delay;
    
    /** Creates a new instance of PARActivityHandler */
    public DELAYActivityHandler() {
    }
    
    @Override
	public boolean handle() {
        if (commitment.getState() == Commitment.STATE_NEW) {
            FOS arg = commitment.getActivity().argAt( 0 );
            if ( arg.getFunctor().equals( "time" ) ) {
                type = TIME;
                time = System.currentTimeMillis();
                delay = Long.parseLong(arg.argAt( 0 ).toString()) - 1;
            } else if ( arg.getFunctor().equals( "iteration" ) ) {
                delay = Long.parseLong(arg.argAt( 0 ).toString()) - 1;
                type = ITERATION;
            } else {
                // Legacy code to cater for lack of quantifier
                delay = Long.parseLong(arg.toString()) - 1;
                type = ITERATION;
            }
            commitment.update(Commitment.EVENT_ACTIVATED);
        } else if (commitment.getState() == Commitment.STATE_ACTIVE) {
            if ( type == TIME ) {
                long now = System.currentTimeMillis();
                if ( ( now - time ) >= delay ) {
                    commitment.update(Commitment.EVENT_SUCCEEDED);
                }
            } else if ( type == ITERATION ) {
                if (delay > 0) {
                    delay--;
                } else {
                    commitment.update(Commitment.EVENT_SUCCEEDED);
                }
            }
        } else if (commitment.getState() == Commitment.STATE_WAITING) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not be in state: STATE_WAITING");
        } else if (commitment.getState() == Commitment.STATE_FAILED) {
            return false;
        } else if (commitment.getState() == Commitment.STATE_REDUNDANT) {
            return false;
        }
        
        return super.handle();
    }
    
    @Override
	public void handleEvent(int event) {
        if (event == Commitment.EVENT_ACTIVATED) {
            commitment.setState(this, Commitment.STATE_ACTIVE);
        } else if (event == Commitment.EVENT_SUCCEEDED) {
            commitment.setState(this, Commitment.STATE_SUCCEEDED);
        } else if (event == Commitment.EVENT_FAILED) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not receive event: EVENT_FAILED");
        } else if (event == Commitment.EVENT_CHILD_SUCCEEDED) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not receive event: EVENT_CHILD_SUCCEEDED");
        } else if (event == Commitment.EVENT_CHILD_FAILED) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not receive event: EVENT_CHILD_FAILED");
        } else if (event == Commitment.EVENT_PARENT_FAILED) {
            commitment.setState(this, Commitment.STATE_FAILED);
        } else if (event == Commitment.EVENT_REDUNDANT) {
            commitment.setState(this, Commitment.STATE_REDUNDANT);
        }
        
        super.handleEvent(event);
    }
}
