/*
 * PARActivityHandler.java
 *
 * Created on 11 November 2005, 09:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.control.cms;
import com.agentfactory.afapl2.interpreter.mentalState.Action;
import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
/**
 *
 * @author Administrator
 */
public class PrimitiveActivityHandler extends ActivityHandler {
    private Action action;
    
    /** Creates a new instance of PARActivityHandler */
    public PrimitiveActivityHandler(Action action) {
        this.action = action;
    }
    
    @Override
	public boolean handle() {
        if (commitment.getState() == Commitment.STATE_NEW) {
            if (action.canPerform() && (agent.query(action.getPreCondition()))) {
                try {
                    agent.scheduleAction(commitment, action);
                } catch (Throwable th) {
                    th.printStackTrace();
                }
            }
            return true;
        } else if (commitment.getState() == Commitment.STATE_SUCCEEDED) {
            action.completed();
            
            // Mauro 
            // Pass success on to parent ( if one exists )
            /*
            Commitment parent = commitment.getParent();
            if (parent != null) {
                parent.update(Commitment.EVENT_CHILD_SUCCEEDED);
            }
            */

        } else if (commitment.getState() == Commitment.STATE_REDUNDANT) {
            return false;
        } else if (commitment.getState() == Commitment.STATE_FAILED) {
            action.completed();
            
            // Pass failure on to parent ( if one exists )
            // Mauro, commented
            /*
            Commitment parent = commitment.getParent();
            if (parent != null) {
                parent.update(Commitment.EVENT_CHILD_FAILED);
            }
            */
            return false;
            
        }
        
        return super.handle();
    }
    
    @Override
	public void handleEvent(int event) {
        if (event == Commitment.EVENT_ACTIVATED) {
            commitment.setState(this, Commitment.STATE_ACTIVE);
        } else if (event == Commitment.EVENT_SUCCEEDED) {
            commitment.setState(this, Commitment.STATE_SUCCEEDED);
        } else if (event == Commitment.EVENT_FAILED) {
            commitment.setState(this, Commitment.STATE_FAILED);
        } else if (event == Commitment.EVENT_CHILD_SUCCEEDED) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not receive event: EVENT_CHILD_SUCCEEDED");
        } else if (event == Commitment.EVENT_CHILD_FAILED) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not receive event: EVENT_CHILD_FAILED");
        } else if (event == Commitment.EVENT_PARENT_FAILED) {
            commitment.setState( this, Commitment.STATE_FAILED );
        } else if (event == Commitment.EVENT_REDUNDANT) {
            commitment.setState(this, Commitment.STATE_REDUNDANT);
        }
        
        super.handleEvent(event);
    }
}
