
/*
 * CommitmentRuleDecoder.java
 *
 * Created on November 5, 2007, 11:02 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
import com.agentfactory.afapl2.interpreter.mentalState.CommitmentRule;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.lang.LogicFactory;
import com.agentfactory.logic.lang.MalformedLogicException;
import com.agentfactory.logic.lang.TerAND;

/**
 *
 * @author remcollier
 */
public class CommitmentRuleDecoder implements Decoder {
    private static final String LOGNAME = CommitmentRuleDecoder.class.getName();
    
    static {
        Logger.getLogger(LOGNAME).setLevel(Level.SEVERE);
    }
    private List<String> statement;
    private int index;
    private CommitmentRule rule;
    
    /** Creates a new instance of CommitmentRuleDecoder */
    public CommitmentRuleDecoder(List<String> statement, int offset) {
        this.statement = statement;
        index = offset;
    }
    
    public CommitmentRuleDecoder(List<String> statement) {
        this(statement, 1);
    }
    
    public void decode() throws DecodeException {
        BeliefSentenceDecoder decoder = new BeliefSentenceDecoder(statement, index);
        decoder.decode();
        
        TerAND condition = null;
        try {
            Object obj = LogicFactory.create(decoder.getBeliefSentence());
            if (FOS.class.isInstance(obj)) {
                condition = new TerAND();
                condition.add((FOS) obj);
            } else {
                condition = (TerAND) obj;
            }
            
        } catch (MalformedLogicException mle) {
            Logger.getLogger(LOGNAME).log(Level.SEVERE, "Failed to create condition of commitment rule: " + statement, mle);
        }
        
        index = decoder.getOffset();
        
        CommitmentDecoder commitmentDecoder = new CommitmentDecoder(statement, index+1);
        commitmentDecoder.decode();
        Commitment commitment = commitmentDecoder.getCommitment();
        index = commitmentDecoder.getOffset();
        rule = new CommitmentRule(condition, commitment);
    }
    
    public int getOffset() {
        return index;
    }
    
    public CommitmentRule getRule() {
        return rule;
    }
}
