/*
 * BeliefDecoder.java
 *
 * Created on November 4, 2007, 8:36 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.List;

/**
 *
 * @author remcollier
 */
public class ComparisonDecoder implements Decoder {
    public static final String EQUAL = "EQUAL";
    public static final String GREATER_THAN = "GREATER_THAN";
    public static final String LESS_THAN = "LESS_THAN";
    
    private List<String> list;
    private String comparison;
    private int index;
    private StringBuffer buf;
    
    /** Creates a new instance of BeliefDecoder */
    public ComparisonDecoder(String comparison, List<String> list) {
        this(comparison, list, 1);
    }
    
    /** Creates a new instance of BeliefDecoder */
    public ComparisonDecoder(String comparison, List<String> list, int offset) {
        this.comparison = comparison;
        this.list = list;
        index = offset;
        buf = new StringBuffer();
    }
    
    public void decode() {
        buf.append(comparison).append("(");
        FOSDecoder decoder = new FOSDecoder(list, index);
        decoder.decode();
        buf.append(decoder.getFOS());
        buf.append(",");
        decoder = new FOSDecoder(list, decoder.getOffset());
        decoder.decode();
        buf.append(decoder.getFOS());
        index = decoder.getOffset();
        buf.append(")");
    }
    
    public String getComparison() {
        return buf.toString();
    }
    
    public int getOffset() {
        return index;
    }
}
