/*
 * ActionDecoder.java
 *
 * Created on November 5, 2007, 8:14 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.agentfactory.logic.MentalAgent;
import com.agentfactory.logic.agent.Module;

/**
 *
 * @author remcollier
 */
public class ModuleDecoder implements Decoder {
    private String id;
    private String module;
    private Map<String,String> configuration;
    
    private List<String> statement;
    private int index;
    
    /** Creates a new instance of ActionDecoder */
    public ModuleDecoder(List<String> statement, int offset) {
        this.statement = statement;
        index = offset;
    }
    
    /** Creates a new instance of ActionDecoder */
    public ModuleDecoder(List<String> statement) {
        this(statement, 1);
    }
    
    public void decode() {
        id = statement.get(index++);
        module = statement.get(index++);
        
        configuration = new HashMap<String,String>();
        String[] item;
        int items = Integer.parseInt(statement.get(index++));
        while (items > 0) {
            item = (statement.get(index++)).split("=");
            configuration.put(item[0], item[1]);
            items--;
        }
    }
    
    public Module getModule(MentalAgent agent) {
        Module mod = null;
        try {
            Class perceptorClass = Class.forName(module);
            mod = (Module) perceptorClass.newInstance();
            mod.setName(id);
            mod.setAgent(agent);
            mod.setConfiguration(configuration);
            mod.init();
        } catch (Exception e) {
            System.out.println("[ModuleDecoder] Problem creating Module: " + id);
            e.printStackTrace();
        }
        
        return mod;
    }
    
    public int getOffset() {
        return index;
    }
}
