package com.agentfactory.agentspeak.compiler;



public class TemplateVisitor implements AgentSpeakParserVisitor {
	public static final String NO_EXTENDS								= "-";
	
	@Override
	public Object visit(SimpleNode node, Object data) {
		if (node.toString().equals("TemplateExpression")) {
			// Get the filename from the url
			String url = (String) data;
			String[] parts = url.split("/");
			parts = parts[parts.length-1].split("\\.");
			String fname = parts[0];
			String ext = parts[1];
			String i = (String) ((SimpleNode) node.jjtGetChild(0)).jjtGetValue();
			if (!i.equals(fname)) throw new InvalidTemplateNameException("template name: '" + i + "' does not match filename: " + url);
			
			if (node.jjtGetNumChildren() == 2) {
				String parent = (String) ((SimpleNode) node.jjtGetChild(1)).jjtGetValue();
				return "/" + parent.replaceAll("\\.", "/") + "." + ext;
			}
			
			return NO_EXTENDS;
		} else {
			Object result = null;
			for (int i=0; i<node.jjtGetNumChildren(); i++) {
				result = visit((SimpleNode) node.jjtGetChild(i), data);
				if (result != null) {
					return result;
				}
			}
		}
		return null;
	}

}
