/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.agentspeak.debugger;

import java.util.LinkedList;

import com.agentfactory.agentspeak.interpreter.AbstractAgentSpeakAgent;
import com.agentfactory.agentspeak.interpreter.Utilities;
import com.agentfactory.agentspeak.interpreter.mentalstate.ASEvent;
import com.agentfactory.agentspeak.interpreter.mentalstate.Intention;
import com.agentfactory.agentspeak.interpreter.mentalstate.PartialPlan;
import com.agentfactory.agentspeak.interpreter.mentalstate.PlanRule;
import com.agentfactory.clf.lang.IMPLIES;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.visualiser.impl.AbstractLanguageAgentStateManager;
import com.agentfactory.visualiser.impl.DefaultSnapshot;

/**
 *
 * @author remcollier
 */
public class AgentSpeakStateManager extends AbstractLanguageAgentStateManager {
    @Override
    protected DefaultSnapshot createSnapshot() {
        return new AgentSpeakSnapshot();
    }
    
    @Override
    protected void constructSnapshot(DefaultSnapshot shot) {
        super.constructSnapshot(shot);
        
        AbstractAgentSpeakAgent agt = (AbstractAgentSpeakAgent) agent;
        AgentSpeakSnapshot snap = (AgentSpeakSnapshot) shot;
        
        if (agt.getEvent() != null) {
        	snap.event = agt.getEvent().toString();
        	for (PlanRule rule: agt.getOptions()) {
        		snap.options.add(rule.toString());
        	}
        	if (agt.getSelected() != null) snap.option = agt.getSelected().toString();
        }
        
        for (ASEvent event: agt.getEventQueue()) {
        	snap.events.add(event.toString());
        }
        
        for(Predicate bel: agt.getBeliefs()) {
        	snap.beliefs.add(Utilities.presenter.toString(bel));
        }
        
        for (IMPLIES inference : agt.getInferences()) {
        	snap.inferences.add(Utilities.presenter.toString(inference));
        }
        for (Intention commitment: agt.getCommitments()) {
        	snap.commitments.add(new IntentionDescription(commitment));
        }
        
        for (String action : agt.getActionLog()) {
        	snap.actionLog.add(action);
        }
        
        snap.rules = agt.getRules();
        snap.plans = new LinkedList<PartialPlan>(agt.getPartialPlans().values());
    }
}
