package com.agentfactory.agentspeak.debugger;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.agentspeak.interpreter.Utilities;
import com.agentfactory.agentspeak.interpreter.mentalstate.Intention;
import com.agentfactory.clf.plans.IPlanStep;
import com.agentfactory.clf.reasoner.Bindings;

public class IntentionDescription {
	public String event;
	public String current;
	public List<String> stack;
	public Bindings bindings;
	public String state;
	
	public IntentionDescription(Intention commitment) {
		event = commitment.getEvent().toString();
		if (commitment.getCurrent() != null) {
			current = commitment.getCurrent().toString();
		}
		stack = new LinkedList<String>();
		for (IPlanStep step: commitment.getStack()) {
			stack.add(step.toString());
		}
		bindings = commitment.bindings().merge(new Bindings());
		state = commitment.stateString();
	}
	
	@Override
	public String toString() {
		String output = event + "<- " + Utilities.presenter.toString(bindings) + "[" + state + "]";
//		output += this.current;
		for (String step: stack) {
			if (step != "") {
				output+= "\n" + step.toString();
			}
		}
		return output + ";\n\n";
	}
}
