package com.agentfactory.agentspeak.interpreter;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.clf.lang.Function;
import com.agentfactory.clf.lang.ITerm;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.clf.util.ILogicFactory;
import com.agentfactory.clf.util.ILogicPresenter;
import com.agentfactory.platform.core.AgentID;

public class Utilities {
    public static String createSignature(Predicate fos) {
        return fos.functor() + ":" + fos.size();
    }
    
    public static AgentID toAgentID(ITerm term) {
    	if (!Function.class.isInstance(term)) return null;
    	
    	Function fos = (Function) term;
    	String id = presenter.toString(fos.termAt(0));
    	List<String> addresses = new LinkedList<String>();
    	Function funct = (Function) fos.termAt(1);
    	for (ITerm t: funct) {
    		addresses.add(presenter.toString(t));
    	}
    	
    	return new AgentID(id, addresses, new LinkedList<String>());
    }
    
    public static final ILogicFactory factory = new AgentSpeakLogicFactory();
    public static final ILogicPresenter presenter = new AgentSpeakLogicPresenter();
}
