package com.agentfactory.agentspeak.interpreter.mentalstate;

import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.lang.Variable;
import com.agentfactory.clf.reasoner.Bindings;

public class AchievementFormula implements IFormula {
	private IFormula formula;
	
	public AchievementFormula(IFormula formula) {
		this.formula = formula;
	}

	@Override
	public IFormula apply(Bindings set) {
		return new AchievementFormula(formula.apply(set));
	}

	@Override
	public List<IFormula> asList() {
		List<IFormula> list = new LinkedList<IFormula>();
		list.add(formula);
		return list;
	}
	
	public IFormula formula() {
		return formula;
	}

	@Override
	public Set<Variable> getVariables() {
		return formula.getVariables();
	}

	@Override
	public boolean isFalse() {
		return formula.isFalse();
	}

	@Override
	public boolean isTrue() {
		return formula.isTrue();
	}

	@Override
	public boolean matches(IFormula formula) {
		if (AchievementFormula.class.isInstance(formula)) {
			return this.formula.matches(((AchievementFormula) formula).formula); 
		}
		return false;
	}

	@Override
	public String type() {
		return formula.type();
	}
}
