package com.agentfactory.astr.compiler;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.astr.interpreter.Utilities;
import com.agentfactory.clf.interpreter.CoreUtilities;
import com.agentfactory.clf.lang.AND;
import com.agentfactory.clf.lang.Bracket;
import com.agentfactory.clf.lang.IFormula;

public class SentenceBuilderVisitor implements ASTRParserVisitor {

	@Override
	public Object visit(SimpleNode node, Object data) {
		if (node.toString().equals("Context")) {
			List<IFormula> list = new LinkedList<IFormula>();
			for (int i=0; i<node.jjtGetNumChildren(); i++) {
				if (node.jjtGetChild(i).toString().equals("Formula")) {
					SimpleNode litNode = (SimpleNode) node.jjtGetChild(i).jjtGetChild(0);
					if (litNode.toString().equals("Literal")) {
						String fos = "";
						if (litNode.jjtGetValue() != null) {
							fos += "~";
						}
						fos += new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						list.add(Utilities.factory.createFormula(fos));
					} else if (litNode.toString().equals("Comparison")) {
						String fos = "" +new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						fos += litNode.jjtGetValue();
						fos += new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(1), null);
						list.add(CoreUtilities.factory.createFormula(fos));
					} else if (litNode.toString().equals("Bracket")) {
						SentenceBuilderVisitor sbv = new SentenceBuilderVisitor();
						AND and = (AND) sbv.visit((SimpleNode) litNode.jjtGetChild(0), null);
						list.add(new Bracket(and));
					} else if (litNode.toString().equals("Contains")) {
						String fos = "$(" +new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(0), null);
						fos += ",";
						fos += new PredicateBuilderVisitor().visit((SimpleNode) litNode.jjtGetChild(1), null);
						list.add(CoreUtilities.factory.createFormula(fos + ")"));
					} else {
						System.out.println("Not Implemented: " + litNode.toString());
					}
				} else {
					System.out.println("Not Implemented: " + node.jjtGetChild(i).toString());
				}
			}
			return new AND(list);
		}
		return null;
	}

}
