package com.agentfactory.astr.debugger.inspector;

import java.awt.BorderLayout;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import com.agentfactory.astr.debugger.ASTRSnapshot;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

public class ActionTracePanel extends JPanel implements InspectorPanel {
    /**
	 * 
	 */
	private static final long serialVersionUID = -6606818554863227166L;
	private JList<String> list;
    private ASTRSnapshot snapshot;
    
    public ActionTracePanel() {
        this.setLayout(new BorderLayout());
        
        list = new JList<String>(new DefaultListModel<String>());        
        JScrollPane pane = new JScrollPane(list);
        this.add(BorderLayout.CENTER, pane);
    }

    public synchronized void update(ISnapshot snapshot) {
        this.snapshot = (ASTRSnapshot) snapshot;
        update();
    }
    
    private void update() {
        DefaultListModel<String> model = new DefaultListModel<String>();
        
        for (String fn : snapshot.actionTrace.keySet()) {
        	for (String action:snapshot.actionTrace.get(fn)) {
                model.add(0,action + " [" + fn + "]");
        	}
        }
        list.setModel(model);
    }
}
