package com.agentfactory.astr.interpreter;

import java.util.Map;

import com.agentfactory.astr.debugger.ASTRStateManagerFactory;
import com.agentfactory.astr.debugger.inspector.ASTRInspectorFactory;
import com.agentfactory.platform.core.ConfigurationException;
import com.agentfactory.visualiser.DebuggerRunConfiguration;

public class ASTRDebugConfiguration extends DebuggerRunConfiguration {
	private String name;
	Map<String, String> designs;
	
	public ASTRDebugConfiguration(String name, Map<String, String> designs) {
		this.name = name;
		this.designs = designs;
	}
	
	public String getName() {
		return name;
	}
	
	public String getDomain() {
		return "agentspeak.ucd.ie";
	}
	
	public void configure() throws ConfigurationException {
		addLanguageSupport(new ASTRInspectorFactory(), new ASTRStateManagerFactory());
		
		super.configure();
		
		addArchitectureFactory(new ASTRArchitectureFactory());

		addAgent("test", "com/agentfactory/astr/interpreter/Test.astr");
//        for (String design: designs.keySet()) {
//        	addAgent(design, designs.get(design));
//        }
	}
	
	public static void main(String[] args) {
		new ASTRDebugConfiguration("test", null).configure();
	}
}
