package com.agentfactory.clf.interpreter;

import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.service.migration.MigrationService;

public class MigrateAPI extends Module {
	MigrationService service;
	
	public MigrateAPI() {
		addAction("setup", new Action() {
			@Override
			public boolean execute(Predicate activity) {
				if (agent.bindToPlatformService(MigrationService.NAME)) {
					service = (MigrationService) agent.getPlatformService(MigrationService.NAME);
					return true;
				}
				return false;
			}
		});
		addAction("go(?host, ?port)", new Action() {
			@Override
			public boolean execute(Predicate activity) {
				if (service == null) {
					addBelief("migrationService(disconnected)");
					return false;
				}

				String host = CoreUtilities.presenter.toString(activity.termAt(0));
				int port = Integer.parseInt(CoreUtilities.presenter.toString(activity.termAt(1)));
				
				service.sendAgent(agent, host, port);
				
				return true;
			}
		});
	}
}
