package com.agentfactory.clf.lang;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.clf.reasoner.Bindings;

public class ListTerm extends Function {

	public ListTerm() {
		super("__list__");
	}

	public ListTerm(List<ITerm> terms) {
		super("__list__", terms);
		// TODO Auto-generated constructor stub
	}
	
	public ListTerm apply(Bindings set) {
		List<ITerm> list = new LinkedList<ITerm>();
		for (ITerm term: this) {
			list.add(term.apply(set));
		}
		return new ListTerm(list);
	}
	
	public boolean equals(Object object) {
		if (ListTerm.class.isInstance(object)) {
			ListTerm list = (ListTerm) object;
			if (list.size() != size()) return false;
			if (list.size() == 0) return true;
			
			int i = 0;
			while (i<size()) {
				if (!list.termAt(i).equals(termAt(i))) {
					return false;
				}
				i++;
			}
			return true;
		}
		return false;
	}
	
	public boolean isConstant() {
		return super.isConstant();
	}

}
