package com.agentfactory.clf.lang;

import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import com.agentfactory.clf.reasoner.Bindings;

public class NOT implements IFormula {
	private IFormula formula;
	
	public NOT(IFormula formula) {
		this.formula = formula;
	}
	
	@Override
	public IFormula apply(Bindings set) {
		return new NOT(formula.apply(set));
	}
	
	public IFormula formula() {
		return formula;
	}
	
	/**
	 * Delegate to the result formula to verify type
	 */
	public String type() {
		return formula.type();
	}
	
	@Override
	public Set<Variable> getVariables() {
		return formula.getVariables();
	}
	
	@Override
	public List<IFormula> asList() {
		List<IFormula> list = new LinkedList<IFormula>();
		list.add(this);
		return list;
	}
	
	public boolean isTrue() {
		return formula.isFalse();
	}

	public boolean isFalse() {
		return formula.isTrue();
	}

	public boolean matches(IFormula formula) {
		if (NOT.class.isInstance(formula)) {
			return formula.matches(((NOT) formula).formula);
		}
		return false;
	}
}
