package com.agentfactory.clf.plans;

import com.agentfactory.clf.interpreter.AbstractLanguageAgent;
import com.agentfactory.clf.interpreter.CoreUtilities;
import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.reasoner.Bindings;
import com.agentfactory.clf.reasoner.QueryResult;

public class WaitStep implements IPlanStep {
	private IFormula guard;
	
	public WaitStep(IFormula guard) {
		this.guard = guard;
	}
	@Override
	public IPlanStep apply(Bindings set) {
		return new WaitStep(guard.apply(set));
	}

	public String toString() {
		return toString("");
	}
	
	public String toString(String tabs) {
		return tabs + "wait (" + CoreUtilities.presenter.toString(guard) + ")";
	}

	public IFormula guard() {
		return guard;
	}

	@Override
	public void handle(AbstractLanguageAgent agent, PlanStack planStack) {
		QueryResult result = agent.queryAll(guard.apply(planStack.bindings()));
		//List<IPlanStep> steps = new LinkedList<IPlanStep>();
		if (!result.found) {
			planStack.back();
		}
	}
}
