package com.agentfactory.logic.lang;

import com.agentfactory.logic.reasoner.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


/**
 *
 * @author Rem Collier
 */
public class TerAND implements Iterable<FOS>,Cloneable {
    private List<FOS> formulae;
    
    public TerAND() {
        formulae = new ArrayList<FOS>();
    }
    
    @Override
    public String toString() {
        StringBuffer s = new StringBuffer();
        
        boolean first = true;
        for (FOS formula:formulae) {
            if (first) {
                first = false;
            } else {
                s.append(" & ");
            }
            s.append(formula.toString());
        }
        
        return s.toString();
    }
    
    public TerAND apply(SubstitutionSet subs) {
        TerAND temp = new TerAND();
        
        for (FOS formula:formulae) {
            temp.formulae.add(formula.apply(subs));
        }
        
        return temp;
    }
    
    public void add(FOS formula) {
        formulae.add(formula);
    }

    public Iterator<FOS> iterator() {
        return formulae.iterator();
    }
    
    @Override
    public Object clone() {
        TerAND and = new TerAND();
        for (FOS formula:formulae) {
            and.formulae.add((FOS) formula.clone());
        }
        return and;
    }
    
    public int numFormulae() {
        return formulae.size();
    }
    
    public FOS getFormula(int index) {
        return formulae.get(index);
    }
}
