/**
 * Title:       TerIMplication.java
 * Copyright:   Copyright (c) 1996-2004 The Agent Factory Working Group. All rights reserved.
 * Licence:     This file is free software; you can redistribute it and/or modify
 *              it under the terms of the GNU Lesser General Public License as published by
 *              the Free Software Foundation; either version 2.1, or (at your option)
 *              any later version.
 *
 *              This file is distributed in the hope that it will be useful,
 *              but WITHOUT ANY WARRANTY; without even the implied warranty of
 *              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *              GNU Lesser General Public License for more details.
 *
 *              You should have received a copy of the GNU Lesser General Public License
 *              along with Agent Factory; see the file COPYING.  If not, write to
 *              the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *              Boston, MA 02111-1307, USA.
 */

package com.agentfactory.logic.lang;

import com.agentfactory.logic.reasoner.SubstitutionSet;

/**
 * TODO -- robertr -- remove the intrusion of ALPHA code into this core class. 
 *
 *
 * @author Terry Lowen
 * @version July 2002
 */
public class TerImplication {
    private TerAND left;
    private FOS right;
    
    public TerImplication(TerAND left, FOS right) {
        this.left = left;
        this.right = right;
    }
    
    public TerAND getLeft() {
        return left;
    }
    
    public FOS getRight() {
        return right;
    }
    
    public String toString() {
        return (left.toString() + " => " + right.toString());
    }
    
    public boolean isRule() {
        return true;
    }
    
    public boolean isCommitmentRule() {
        return right.getFunctor().equals("COMMIT");
    }
    
    public boolean equals(Object object) {
        if (!(object instanceof TerImplication)) {
            return false;
        }
        
        TerImplication imp = (TerImplication) object;
        return imp.left.equals(left) && imp.right.equals(right);
    }
    
    public TerImplication apply(SubstitutionSet binding) {
        return new TerImplication(left.apply(binding), right.apply(binding));
    }
}
