/*
 * Queryable.java
 *
 * Created on April 16, 2007, 1:13 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.logic.reasoner;

import com.agentfactory.logic.lang.FOS;
import java.util.List;

/**
 * This interface specifies all methods required by a Knowledge Source (i.e. a
 * database that contains items that can be queried, such as beliefs, goals,
 * desires, ...).
 *
 * @author Rem Collier
 */
public interface Queryable {
    /**
     * Check whether the KS supports the specified type of item
     *
     * @param type the type of KS being searched for
     * @return true if the KS holds items of that type, false otherwise
     */
    public boolean hasType( String type );
    
    /**
     * Query the KS for items that match the specified query.  This method
     * assumes that the has Type method has been invoked prior to its
     * invocation.
     *
     * @param query the item being searched for
     * @return a list of matching items.
     */
    public List<Object> query( FOS query );
}
