/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.logic.util;

import com.agentfactory.logic.lang.FOS;
import com.agentfactory.platform.core.AgentID;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author remcollier
 */
public class Support {
    /**
     * Constructor that takes input in FOS form. Input should conform to:
     * agentID(name, addresses(?addr1, ?addr2, ...), resolvers(?res1, ?res2, ...))
     * The resolvers part of the agentID is optional.
     *
     * @param fos the FOS object to be parsed.
     */
    public static AgentID convert(FOS fos) {
        String name = fos.argAt(0).toString();
        
        // Add addresses
        List<String> addresses = new ArrayList<String>();
        FOS args = fos.argAt(1);
        for (int i = 0; i < args.numArguments(); i++) {
            addresses.add(args.argAt(i).toString());            
        }
        
        // Add resolvers (optional)
        List<String> resolvers = new ArrayList<String>();
        if (fos.numArguments() == 3) {
            args = fos.argAt(2);
            for (int i = 0; i < args.numArguments(); i++) {
                resolvers.add(args.argAt(i).toString());
            }
        }
        
        // Add servicedescriptions (optional)
        List<String> servicedescriptions = new ArrayList<String>();
        if (fos.numArguments() == 4) {
            args = fos.argAt(3);
            for (int i = 0; i < args.numArguments(); i++) {
                servicedescriptions.add(args.argAt(i).toString());
            }
        }
        
        return new AgentID(name, addresses, resolvers);
    }

}
