/**
 * Title:       Constants.java
 * Copyright:   Copyright (c) 1996-2004 The Agent Factory Working Group. All rights reserved.
 * Licence:     This file is free software; you can redistribute it and/or modify
 *              it under the terms of the GNU Lesser General Public License as published by
 *              the Free Software Foundation; either version 2.1, or (at your option)
 *              any later version.
 *
 *              This file is distributed in the hope that it will be useful,
 *              but WITHOUT ANY WARRANTY; without even the implied warranty of
 *              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *              GNU Lesser General Public License for more details.
 *
 *              You should have received a copy of the GNU Lesser General Public License
 *              along with Agent Factory; see the file COPYING.  If not, write to
 *              the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *              Boston, MA 02111-1307, USA.
 */
package com.agentfactory.platform.core;

/**
 * Various constants used in the implementation of FIPA Messaging Support for
 * Agent Factory.
 *
 * @author  Rem Collier
 */
public class Constants {
    public final static String HTTP11                               = "HTTP/1.1";
    public final static String ACC_PATH                             = "/acc";
    public final static String ACTION                               = "POST";
    public final static String CRLF                                 = "\r\n";
    public final static String CONTENT_TYPE                         = "Content-Type";
    public final static String XML_ENVELOPE_TYPE                    = "xml";
    public final static String FIPA_XML_ENVELOPE_TYPE               = "fipa.mts.env.rep.xml.std";
    public final static String FIPA_STRING_MESSAGE_TYPE             = "fipa.acl.rep.string.std";
    public final static String FIPA_MESSAGE_MODULE_CLASS            = "com.agentfactory.plugins.core.fipa.module.FIPAMessageModule";
}
