package com.agentfactory.platform.core;

import java.util.Collection;
import java.util.Properties;

/**
 * Interface to be implemented by platform services
 * @author daithi
 */
public interface IPlatformService {

    public static final int DEFAULT_PRIORITY = -1;

    public String getName();
    public void configure( Properties config, IPlatformServiceManager manager );
    public void setPriority( int priority );
    public int getPriority();
    public Collection<IAgent> getBoundAgents();
    public void setName( String serviceName );
    public void unbind( IAgent agent );
    public void bind( IAgent agent );
    public void start();
    public void stop();
}
