/*
 * VRWClientTreadUDP.java
 *
 * Created on 23 May 2005, 13:24
 */

package com.agentfactory.service.mts.udp;

import com.agentfactory.platform.impl.StringMessage;
import java.io.*;
import java.net.*;
import java.util.*;
/**
 *
 * @author  Administrator
 */
public class UDPReceiver extends Thread {
    private UDPMessageTransportService service;
    MulticastSocket m_socket = null;
    String m_strHostName = null;
    String m_strTestAgentName;
    Thread m_thread = null;
    boolean m_bSuspended = false;
    
    public UDPReceiver(UDPMessageTransportService service) throws IOException {
        this.service = service;
        
        if (service.getInetAddress().isMulticastAddress()) {
            m_socket = new MulticastSocket(service.getPort());
            if ( service.getInterface() != null ) {
                m_socket.setNetworkInterface( NetworkInterface.getByName(service.getInterface()));
            }
            System.out.println(m_socket.getNetworkInterface());
            Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces();
            while(en.hasMoreElements()) {
                System.out.println( en.nextElement() );
            }
            ((MulticastSocket)m_socket).joinGroup(service.getInetAddress());
        }
        m_thread = this;
    }
    
    public void run() {
        while (m_thread != null) {
            
            if (m_bSuspended) {
                synchronized(this) {
                    try {
                        wait();
                    } catch (InterruptedException e) {}
                }
            }
            
            String strCmd = receive();
            service.receiveMessage(StringMessage.newInstance(strCmd));
        }
        
        close();
    }
    
    public int getPort() {
        return m_socket.getLocalPort();
    }
    
    public void close() {
        m_socket.close();
    }
    
    public String receive() {
        try {
            byte[] buf = new byte[8192];
            // receive request
            DatagramPacket packet = new DatagramPacket(buf, buf.length);
            m_socket.receive(packet);
            String strCmd = new String(packet.getData()).trim();
            
            return strCmd;
            
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }
    
    
}
