package com.agentfactory.teleoreactive.debugger;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.clf.interpreter.Action;
import com.agentfactory.clf.interpreter.CoreUtilities;
import com.agentfactory.clf.interpreter.Sensor;
import com.agentfactory.teleoreactive.interpreter.AbstractTeleoReactiveAgent;
import com.agentfactory.teleoreactive.interpreter.mentalstate.TRProgram;
import com.agentfactory.visualiser.impl.DefaultSnapshot;
import com.agentfactory.visualiser.impl.DefaultStateManager;

public class TeleoReactiveStateManager extends DefaultStateManager {
	
	public TeleoReactiveStateManager(){
		super();
	}
	
	protected DefaultSnapshot createSnapshot() {
		return new TeleoReactiveSnapshot();
	}

	protected void constructSnapshot(DefaultSnapshot shot) {
		super.constructSnapshot(shot);

		AbstractTeleoReactiveAgent agt = (AbstractTeleoReactiveAgent) agent;
		TeleoReactiveSnapshot snap = (TeleoReactiveSnapshot) shot;

		snap.currentBeliefs = agt.getBeliefs();
		snap.programStack = agt.getStack();
		snap.actionTrace = agt.getActionTrace();
		List<String> an = new LinkedList<String>();
		for(Action a:agt.getActions()){
			an.add(CoreUtilities.presenter.toString(a.getId()));
		}
		snap.Actions = an;
		List<String> ab = new LinkedList<String>();
		for(Sensor a:agt.getSensors()){
			ab.add(CoreUtilities.presenter.toString(a.getId()));
		}
		snap.Sensors = ab;
		List<String> l = new LinkedList<String>();
		for(TRProgram p: agt.getPrograms().values()){
			for(String s: p.getFunction())
			l.add(s);
		}
		snap.Functions=l;
	}
}