package com.agentfactory.visualiser;

import java.awt.Graphics;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Misc utility methods
 * 
 * @author Zhenhua Yang
 */
public class MiscUtils {
	
	/**
	 * Average width (pixels) of a character on a <code>Graphics</code>.
	 * (NOT ACCUTE!)
	 * 
	 * @param g - a Graphics
	 * 
	 * @return width (pixels)
	 */
	public static int getAverageCharacterWidthOnGraph(Graphics g) {
		int[] sizes = g.getFontMetrics().getWidths();
		
		int total = 0;
		for (int i = 0; i < sizes.length; i++) {
			total += sizes[i];
		}
		
		return total / sizes.length; 
	}
	
	/**
	 * Formats a timestamp to String
	 * 
	 * @param datetime - timestamp to be formatted
	 * 
	 * @return String representation of the timestamp
	 */
	public static String formatSentTime(Date datetime) {
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
		return format.format(datetime);
	}

}
