/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.visualiser.impl;

import java.util.List;

import com.agentfactory.clf.interpreter.AbstractLanguageAgent;
import com.agentfactory.clf.interpreter.Action;
import com.agentfactory.clf.interpreter.Module;
import com.agentfactory.clf.interpreter.Sensor;
import com.agentfactory.platform.core.IAgent;
import com.agentfactory.visualiser.core.ISnapshot;

/**
 *
 * @author remcollier
 */
public class AbstractLanguageAgentStateManager extends DefaultStateManager  {
    
    protected void constructSnapshot(DefaultSnapshot shot) {
    	super.constructSnapshot(shot);
    	
    	AbstractLanguageAgentSnapshot snap = (AbstractLanguageAgentSnapshot) shot;
    	AbstractLanguageAgent agt = (AbstractLanguageAgent) agent;
    	
		for (Action action: agt.getActions()) {
			snap.actions.add(new ComponentDescription(action.getId(), action.getClass().getName()));
		}
        
		for (Sensor sensor: agt.getSensors()) {
			snap.sensors.add(new ComponentDescription(sensor.getId(), sensor.getClass().getName()));
		}
		for (Module module: agt.getModuleMap().values()) {
			snap.modules.add(new ComponentDescription(module.getId(), module.getClass().getName()));
		}
    }
}
