/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.visualiser.impl;

import java.util.Date;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Observable;
import java.util.Observer;
import java.util.Set;

import com.agentfactory.platform.core.AgentID;
import com.agentfactory.platform.core.IMessage;
import com.agentfactory.service.profiler.TraceEvent;
import com.agentfactory.visualiser.InteractionRecord;

/**
 *
 * @author remcollier
 */
public class MessageStore extends Observable implements Observer {
    LinkedList<InteractionRecord> messages;
    Set<AgentID> agentIDs;
    
    public MessageStore() {
        messages = new LinkedList<InteractionRecord>();
        agentIDs = new HashSet<AgentID>();
    }
    
    public List<InteractionRecord> getInteractionRecords() {
        return messages;
    }
    
    public Set<AgentID> getAllAIDs() {
    	return agentIDs;
    }
    
    public synchronized void update(Observable o, Object arg) {
        if (TraceEvent.class.isInstance(arg)) {
            TraceEvent evt = (TraceEvent) arg;
            if (evt.getType().equals("message/send")) {
            	IMessage message = (IMessage) evt.getContext();
            	checkAgentID(message.getSender());
            	for (AgentID aid: message.getReceivers()) {
            		checkAgentID(aid);
            	}
            	
                messages.addLast(new InteractionRecord(new Date(), (IMessage) evt.getContext()));
                if (messages.size() > 1000) messages.removeFirst();
                setChanged();
                notifyObservers("new-messages");
            }
        }
    }

    private void checkAgentID(AgentID aid) {
    	if (!agentIDs.contains(aid)) {
    		agentIDs.add(aid);
    	}
    }
}
