/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.visualiser.impl;

import com.agentfactory.platform.core.IMessage;
import com.agentfactory.visualiser.core.ISnapshot;
import java.awt.BorderLayout;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JToolBar;

/**
 * 
 * @author remcollier
 */
public class MessagesPanel extends JPanel implements InspectorPanel {

   private static final long serialVersionUID = -8157433912926628455L;
   private JList incoming, outgoing;

   public MessagesPanel() {
      this.setLayout( new BorderLayout() );
      JSplitPane pane = new JSplitPane( JSplitPane.VERTICAL_SPLIT );

      incoming = new JList( new DefaultListModel() );
      outgoing = new JList( new DefaultListModel() );

      JPanel panel = new JPanel();
      panel.setLayout( new BorderLayout() );
      JToolBar toolbar = new JToolBar();
      toolbar.add( new JLabel( "Incoming:" ) );
      panel.add( BorderLayout.NORTH, toolbar );
      JScrollPane scrollPane = new JScrollPane( incoming );
      panel.add( BorderLayout.CENTER, scrollPane );
      pane.setTopComponent( panel );

      panel = new JPanel();
      panel.setLayout( new BorderLayout() );
      toolbar = new JToolBar();
      toolbar.add( new JLabel( "Outgoing:" ) );
      panel.add( BorderLayout.NORTH, toolbar );
      scrollPane = new JScrollPane( outgoing );
      panel.add( BorderLayout.CENTER, scrollPane );
      pane.setBottomComponent( panel );

      this.add( BorderLayout.CENTER, pane );
   }

   public synchronized void update( ISnapshot snapshot ) {
      DefaultListModel inModel = (DefaultListModel) incoming.getModel();
      DefaultListModel outModel = (DefaultListModel) outgoing.getModel();
      inModel.removeAllElements();
      outModel.removeAllElements();

      for ( IMessage message : snapshot.getInbox() ) {
         inModel.addElement( message );
      }

      for ( IMessage message : snapshot.getOutbox() ) {
         outModel.addElement( message );
      }
   }
}
